# Based on the ttypager and supporting functions from pydoc, under the Python
# license, with various improvements.

import bits
import pager
import redirect
import string
import sys

def getpager():
    return ttypager

def plain(text):
    """Remove boldface formatting from text."""
    import re
    return re.sub('.\b', '', text)

def ttypager(text):
    """Page through text on a text terminal."""
    with pager.nopager():
        with redirect.nolog():
            prompt = '-- any key to advance; PgUp to page up; q to quit --'
            prompt_len = len(prompt)
            lines = string.split(plain(text), '\n')
            height = min(bits.get_width_height(term)[1] for term in range(bits.get_term_count()))
            r = inc = height - 1
            sys.stdout.write(string.join(lines[:inc], '\n') + '\n')
            while lines[r:]:
                sys.stdout.write(prompt)
                c = sys.stdin.read(1)
                # Write the spaces one at a time to defeat word-wrap
                sys.stdout.write('\r')
                for i in range(prompt_len):
                    sys.stdout.write(' ')
                sys.stdout.write('\r')
                if c in ('q', 'Q'):
                    break
                elif c in ('\r', '\n', '\x0e'):
                    sys.stdout.write(lines[r] + '\n')
                    r = r + 1
                    continue
                if c in ('\x10'):
                    bits.clear_screen()
                    r = r - 1 - inc
                    if r < 0:
                        r = 0
                if c in ('\x07', 'b', 'B'):
                    bits.clear_screen()
                    r = r - inc - inc
                    if r < 0:
                        r = 0
                sys.stdout.write(string.join(lines[r:r+inc], '\n') + '\n')
                r = r + inc
